
      SUBROUTINE NDATA
C
C     STANDARD DATA READ SETUP
C
      DIMENSION TT(5),TX(5)
      DIMENSION XX(1000),XT(1000),XPH(1000),XPH2(1000),XB(1000)
      DIMENSION BMEAN(101),BS2(101),BPH(101),TIT(20)
      COMMON /X/ XX,XT,XPH,XB,BMEAN,BS2,BPH,XPH2,TIT
      COMMON /N/ NDAT,MODE,NB,NCOV,NF,NDEG,IPUNCH,METHOD,NBIN
     1 ,NSEG,NSN(21)
      COMMON /P/ PERMAX,PERMID,PERMIN,FMIN,FMID,FMAX,DELF,PER,FREQ,
     1   TRANGE,DTBAR,SIG2,AMEAN,PRSIG,PLSIG,TENSE,BNJ,RSIG,YMN,YMX
C
      MODE=2

 100  FORMAT(I10)
 101  FORMAT(8F10.0)
      READ(15,100) NDAT
      J=0
      NCARD=4
      DO 14 II=1,NDAT
      READ(15,101) (TT(I),TX(I),I=1,NCARD)
      DO 15 I=1,NCARD
      IF(TT(I).LT..01) GO TO 15
      J=J+1
      XT(J)=TT(I)
      XX(J)=TX(I)
 15   CONTINUE
 14   CONTINUE
      NDAT=J
C
C     DATA SELECT-TAKE NDAT POINTS, STARTING WITH POINT IFRST
      NDAT=NDAT
      IFRST=1
      DO 2 I=1,NDAT
      XX(I)=XX(I+IFRST-1)
      XT(I)=XT(I+IFRST-1)
 2    CONTINUE
C*****
      DO 1 I=1,NDAT
 1    XX(I)=-XX(I)
C*****
      RETURN
C
      ENTRY SEGSET
C*****
      NSEG=4
      XPH(1)=38000.
      XPH(2)=40000.
      XPH(3)=43200.
C*****
      RETURN
C
      ENTRY RESET
      RETURN
      END

C**********PDM**********PDM**********PDM**********PDM**********
C
C
C
C     PERIOD ANALYSIS VIA PHASE DISPERSION MINIMIZATION
C     VERSION 2, STELLINGWERF, RUTGERS,1979
C     VAX/VMS VERSION, MRC, 1981
C     MODE=1..DEBUG, MODE=2..ROUGH CUT, MODE=3..FINE SCAN
C        IF MODE=4..NO DEFAULT VALUES ARE SET
C     METHOD=2..USE WHITTAKER, ROBINSON TECHNIQUE
C        MAXIMIZE MEAN CURVE AMPLITUDE
C     MULTIPLE DATA REDUCTION
C        FREQUENCIES READ BY REDUCE FROM CARDS
C        SET IPUNCH=1 TO PUNCH REDUCED DATA
C     FOR SEGMENTAL AVERAGING SET NSEG=NUMBER OF SEGMENTS
C        ALSO SET XPH(I)=STARTING TIME OF SEGMENT I+1
C     USER SUPPLIED ROUTINES..NDATA,RESET,SEGSET
C
      DIMENSION XX(1000),XT(1000),XPH(1000),XPH2(1000),XB(1000)
      DIMENSION BMEAN(101),BS2(101),BPH(101),TIT(20)
      DIMENSION THETA(500),TFREQ(500),BM2(101),BPH2(101)
      COMMON /X/ XX,XT,XPH,XB,BMEAN,BS2,BPH,XPH2,TIT
      COMMON /N/ NDAT,MODE,NB,NCOV,NF,NDEG,IPUNCH,METHOD,NBIN
     1 ,NSEG,NSN(21)
      COMMON /P/ PERMAX,PERMID,PERMIN,FMIN,FMID,FMAX,DELF,PER,FREQ,
     1   TRANGE,DTBAR,SIG2,AMEAN,PRSIG,PLSIG,TENSE,BNJ,RSIG,YMN,YMX
C     NAMELIST /PARAM/ FMIN,PERMAX,FMID,PERMID,FMAX,PERMIN,NF,DELF,
C    1   NB,NCOV,PRSIG,PLSIG,FFMIN,FFMID,FFMAX
C
C     READ TITLE
C
 105  FORMAT(20A4)
      READ(15,105) (TIT(I),I=1,20)
C
 100  FORMAT(1X,44('PDM'))
 99   FORMAT(1H1)
      WRITE(16,99)
      WRITE(16,100)
      WRITE(16,100)
      WRITE(16,100)
C
C     SET DIMENSIONS
      MAXX=1000
      MAXF=500
      MAXBIN=101
      MAXSEG=20
C     ZERO COMMON BLOCKS
      CALL ZERO
      TENSE=1.
      RSIG=0.5
C
C     SET DATA-XX,XT,NDAT,MODE
C
      CALL NDATA
      IF(NDAT.LE.0.OR.NDAT.GT.MAXX) MODE=1
C
C     SORT DATA
      CALL SORT(NDAT,2,XT,XX,T1)
C
C     DATA REDUCTION
      CALL REDUCE
C
C     SET SEGMENTS IF DESIRED..NSEG, PUT TSEG IN XPH
C        TSEG(I)=TIME VALUE SEPARATING SEG(I) AND SEG(I+1)
      CALL SEGSET
C
      IF(NSEG.EQ.0) NSEG=1
      IF(NSEG.GT.MAXSEG) NSEG=MAXSEG
      NSN(1)=1
      NSN(NSEG+1)=NDAT+1
      IF(NSEG.EQ.1) GO TO 4
      ISEG=2
      DO 3 I=2,NDAT
      IF(XT(I).LT.XPH(ISEG-1)) GO TO 3
      NSN(ISEG)=I
      ISEG=ISEG+1
      IF(ISEG.GT.NSEG) GO TO 4
 3    CONTINUE
 4    CONTINUE
 101  FORMAT(1X,13(2X,I8))
 102  FORMAT(1X,1P13E10.2)
 103  FORMAT('0SORTED DATA...N',8X,'T',14X,'X'/)
 104  FORMAT(12X,I5,1P2D15.6)
      IF(MODE.EQ.1) WRITE(16,101) NDAT,MODE,NSEG,(NSN(I),I=1,NSEG)
      IF(MODE.NE.1) GO TO 5
      WRITE(16,103)
      DO 6 I=1,NDAT
      WRITE(16,104) I,XT(I),XX(I)
 6    CONTINUE
 5    CONTINUE
C     OVERALL DATA REVIEW, DEBUG ONLY
      IF(MODE.EQ.1) CALL DATSUM
C
C     COMPUTE TIME STATISTICS, POINTS MUST BE WELL ORDERED
      TRANGE=0.
      DTBAR=0.
      SIG2=0.
      AMEAN=0.
      DO 2 ISEG=1,NSEG
      N1=NSN(ISEG)+1
      N2=NSN(ISEG+1)-1
      DT=XT(N1)-XT(N1-1)
      DT1=DT
      DT2=DT
      DO 1 I=N1,N2
      DT=XT(I)-XT(I-1)
      DT1=AMIN1(DT1,DT)
      DT2=AMAX1(DT2,DT)
1     CONTINUE
      TR=XT(N2)-XT(N1-1)
      NSS=N2-N1+1
      DTBAR=TR/NSS+DTBAR
      TRANGE=AMAX1(TRANGE,TR)
      CALL VARM(NSS,XX(N1),SIGS,AMEANS)
      SIG2=SIG2+(NSS-1)*SIGS
      AMEAN=AMEAN+NSS*AMEANS
 2    CONTINUE
      DTBAR=DTBAR/NSEG
      SIG2=SIG2/(NDAT-NSEG)
      AMEAN=AMEAN/NDAT
      IF(MODE.EQ.1) WRITE(16,102) DTBAR,TRANGE,SIG,SIG2,AMEAN
C
C     SET DEFAULTS
C
C        DEBUG--TWENTY POINTS,MIDRANGE,LOW RESOLUTION
      FFMAX=1./(2.*DTBAR)
      FFMIN=1./TRANGE
      FFMID=(FFMAX+FFMIN)/2.
      IF(MODE.GT.1) GO TO 21
      FMID=FFMID
      NF=20
      DELF=1./(5.*TRANGE)
      GO TO 20
 21   CONTINUE
C        ROUGH CUT--500 POINTS, FULL RANGE, LOW RESOLUTION
      IF(MODE.GT.2) GO TO 22
      DELF=1./(5.*TRANGE)
      NFF=(FFMAX-FFMIN)/DELF
      NF=500
      IF(NFF.LE.1000) FMIN=FFMIN
      IF(NFF.GT.1000) FMID=FFMID
      GO TO 20
 22   CONTINUE
C        FINE SCAN--201 POINTS,HIGH RESOLUTION,SET FMID OR PERMID IN RES
      IF(MODE.GT.3) GO TO 20
      NF=201
      DELF=1./(100.*TRANGE)
      GO TO 20
 20   CONTINUE
C
C     STANDARD BIN STRUCTURE--10 BINS,DOUBLE COVER=(5,2)
      NB=5
      NCOV=2
C
C     OUTPUT PARAMETERS
      PRSIG=0.50
      PLSIG=0.05
      IF(MODE.EQ.3) PLSIG=-1.0
      IF(MODE.EQ.1) WRITE(16,*) FMIN,PERMAX,FMID,PERMID,FMAX,PERMIN
     1  ,NF,DELF,NB,NCOV,PLSIG,FFMIN,FFMID,FFMAX
C
C     USE RESET TO ADJUST PARAMETERS
      CALL RESET
      IF(MODE.EQ.1) WRITE(16,*) FMIN,PERMAX,FMID,PERMID,FMAX,PERMIN
     1  ,NF,DELF,NB,NCOV,PLSIG,FFMIN,FFMID,FFMAX
C
C     NOW GENERATE FMIN,DELF,NF FROM GIVEN PARAMETERS
C
      IF(PERMAX.NE.0.) FMIN=1./PERMAX
      IF(PERMID.NE.0.) FMID=1./PERMID
      IF(PERMIN.NE.0.) FMAX=1./PERMIN
      IF(NF*DELF.EQ.0.) GO TO 31
C        NF AND DELF BOTH SET
      IF(FMIN.NE.0.) GO TO 30
      IF(FMAX.NE.0.) FMIN=FMAX-NF*DELF
      IF(FMID.NE.0.) FMIN=FMID-NF*DELF/2.
      GO TO 30
 31   CONTINUE
C        TWO FREQUENCIES SPECIFIED, SET FMIN AND FMAX
      IF(FMIN.EQ.0.) FMIN=FMID*2-FMAX
      FMIN=AMAX1(FMIN,FFMIN)
      IF(FMAX.EQ.0.) FMAX=2.*FMID-FMIN
      IF(FMAX.LE.FMIN) STOP 11
      IF(NF.NE.0) GO TO 32
      IF(DELF.EQ.0) STOP 10
C        DELF SPECIFIED
      NF=(FMAX-FMIN)/DELF
      GO TO 30
 32   CONTINUE
C        NF SPECIFIED
      DELF=(FMAX-FMIN)/NF
 30   CONTINUE
      IF(MODE.EQ.1) WRITE(16,*) FMIN,PERMAX,FMID,PERMID,FMAX,PERMIN
     1  ,NF,DELF,NB,NCOV,PLSIG,FFMIN,FFMID,FFMA
C        CHECKS
      IF(MODE.EQ.1) NF=20
      NF=MIN0(NF,MAXF)
      IF(NB*NCOV.EQ.0) STOP 12
      FMIN=AMAX1(FMIN,FFMIN)
C
C     DEGREES OF FREEDOM FOR CHI**2
      NDEG=(NDAT-NB*NSEG)*NCOV
C     DEGREES OF FREEDOM FOR F-TEST
      NDF1=NDAT-NSEG
      NDF2=NDEG
C     WR CASE
      IF(METHOD.NE.2) GO TO 33
      NDEG=(NB*NCOV-1)*NSEG
      NDF1=NDEG
      NDF2=NDAT-NSEG
 33   CONTINUE
C
C     PRINT HEADER
C
      SIG=SQRT(SIG2)
 300  FORMAT(1H0)
 301  FORMAT(////)
      WRITE(16,300)
      WRITE(16,302)
 302  FORMAT(30X,'SPECTRAL ANALYSIS USING PHASE DISPERSION MINIMIZATION,
     1 VERSION 2 - 1979')
      WRITE(16,300)
      WRITE(16,322) TIT
 322  FORMAT(25X,20A4)
      WRITE(16,301)
      IF(METHOD.EQ.2) WRITE(16,298)
 298  FORMAT(5X,'WHITTAKER-ROBINSON TECHNIQUE'//)
      WRITE(16,303) MODE
 303  FORMAT(5X,'CALCULATION MODE=',I2,'...')
      GO TO(41,42,43,44),MODE
 41   WRITE(16,304)
      GO TO 45
 42   WRITE(16,305)
      GO TO 45
 43   WRITE(16,306)
      GO TO 45
 44   CONTINUE
      WRITE(16,299)
 45   CONTINUE
 304  FORMAT(1H+,27X,'DEBUG')
 305  FORMAT(1H+,27X,'ROUGH CUT')
 306  FORMAT(1H+,27X,'FINE SCAN')
 299  FORMAT(1H+,27X,'ALL PARAMETERS SET BY RESET')
      WRITE(16,307) NDAT
 307  FORMAT(1H0,4X,'NUMBER OF DATA POINTS=',I5/)
      IF(NSEG.EQ.1) GO TO 60
      WRITE(16,601) NSEG
 601  FORMAT(5X,'SEGMENTAL AVERAGING IN EFFECT,',I3,' SEGMENTS')
      WRITE(16,602)
 602  FORMAT(10X,'SEG NUMBER     START POINT     START TIME')
      DO 61 I=1,NSEG
      N2=NSN(I)
 61   WRITE(16,603) I,N2,XT(N2)
 603  FORMAT(14X,I3,10X,I5,9X,1PE10.3)
      WRITE(16,300)
 60   CONTINUE
      WRITE(16,308)  XT(1),XT(NDAT),TRANGE
 308  FORMAT(5X,'TIME RANGE',5X,1PE10.3,2X,'TO',E10.3,5X,'TOTAL=',E10.3)
      WRITE(16,309) DT1,DT2,DTBAR
 309  FORMAT(5X,'TIMESTEP RANGE ',1PE10.3,2X,'TO',E10.3,6X,'MEAN=',E10.3
     1)
      WRITE(16,310) AMEAN,SIG,SIG2
 310  FORMAT(1H0,4X,'MEAN DATA VALUE=',1PE10.3,4X,'STANDARD DEVIATION=',
     1   E10.3,4X,'VARIANCE=',E10.3//)
      WRITE(16,311)
 311  FORMAT(1X,'FINAL PARAMETER VALUES, ZERO IF UNSPECIFIED'/)
      WRITE(16,312) FMIN,PERMAX
 312  FORMAT(5X,'MINIMUM FREQUENCY=',1PE10.3,'  MAXIMUM PERIOD=',E10.3)
      WRITE(16,313) FMID,PERMID
 313  FORMAT(5X,'MEAN FREQUENCY=',3X,1PE10.3,'  MEAN PERIOD=',3X,E10.3)
      WRITE(16,314) FMAX,PERMIN
 314  FORMAT(5X,'MAXIMUM FREQUENCY=',1PE10.3,'  MINIMUM PERIOD=',E10.3)
      WRITE(16,315) DELF,NF
 315  FORMAT(5X,'FREQUENCY STEP=',3X,1PE10.3,'  NUMBER OF TRIAL FREQUENC
     1IES=',I5/)
      WRITE(16,316) NB,NCOV
 316  FORMAT(5X,'NUMBER OF BINS IN COVER=',I4,4X,'NUMBER OF COVERS=',I2/
     1//)
      WRITE(16,317)
 317  FORMAT(1X,'STATISTICAL INFORMATION AND CONTROLS'/)
      WRITE(16,318) NDEG,NDF1,NDF2
 318  FORMAT(5X,'DEGREES OF FREEDOM FOR CHI-SQUARE=',I5,6X,
     1          'DEGREES OF FREEDOM FOR F-TEST=',I5,',',I5/)
      WRITE(16,319) PRSIG,PLSIG
 319  FORMAT(5X,'MAXIMUM SIGNIFICANCE FOR PRINT OR PLOT AT MINIMUM=',
     1   F7.4,',',F7.4)
      WRITE(16,99)
      WRITE(16,321)
 321  FORMAT(1X,32('*'),'LIST OF SIGNIFICANT THETA MINIMA',32('*'),//)
C
C     BEGIN CALCULATION
C
      NPLT=0
      NMIN=0
      IHEAD=1
      DO 10 IF=1,NF
      FREQ=FMIN+(IF-1)*DELF
      CALL PDM(THETAF)
      THETA(IF)=THETAF
      TFREQ(IF)=FREQ
C        CHECK FOR MINIMUM
      IF(IF.EQ.NF.AND.THETA(IF).LT.THETA(IF-1)) GO TO 15
      IF(IF.EQ.2.AND.THETA(2).GT.THETA(1)) GO TO 15
      IF(IF.LT.3) GO TO 11
      IF(THETA(IF).LT.THETA(IF-1).OR.THETA(IF-2).LT.THETA(IF-1))GO TO 11
 15   CONTINUE
      FREM=FREQ-DELF
C        MINIMUM FOUND, CHECK SIGNIFICANCE
      NMIN=NMIN+1
      CHI2=NDEG*THETA(IF-1)
      NJ=BNJ
      IF(METHOD.EQ.2) CHI2=NDEG*NJ*(NBIN-3)*(1.-THETA(IF-1))/(NBIN-1)
      F=NDEG/CHI2
      IF(METHOD.EQ.2) F=1./F
      Z=0.
      SIGM=PCHI(Z,F,NDF1,NDF2,2)
      IF(F.LT.1) SIGM=1.
      IF(SIGM.GT.PRSIG) GO TO 11
      PER=1./FREM
      IF(IHEAD.NE.0) WRITE(16,320)
 320  FORMAT(1X,'IMIN',8X,'FREQUENCY',7X,'PERIOD',10X,'THETA',6X,'SIGNIF
     1ICANCE',9X,'F',11X,'CHI**2'/)
      WRITE(16,400) NMIN,FREM,PER,THETA(IF-1),SIGM,F,CHI2
 400  FORMAT(1X,I4,3X,1P6E15.5)
      IHEAD=0
      IF(SIGM.GT.PLSIG) GO TO 11
      NPLT=NPLT+1
      IF(NPLT.GT.20) PLSIG=-1.
      IYM=53
C     NOTE...FIRST SEGMENT DATA PLOTTED...
C            LAST SEGMENT MEAN CURVE PLOTTED, MAY NOT AGREE
      NDDD=NSN(2)-1
      IF(NDDD.GE.505) IYM=NDDD/5.
      CALL PLOT1(XPH2,XX,XPH2,XB,NDDD,IYM,0.,0.,1)
      WRITE(16,401) NMIN
 401  FORMAT(40X,'DATA VERSUS PHASE AT THETA MINIMUM NUMBER',I4)
 12   CALL PLOT1(BPH2,BM2,BPH2,BM2,NBIN2,53,0.,0.,1)
      WRITE(16,402) NMIN
 402  FORMAT(35X,'MEAN CURVE VERSUS PHASE AT THETA MINIMUM NUMBER',I4)
      IHEAD=1
 11   CONTINUE
      NBIN2=NBIN
      DO 13 I=1,NBIN
      BPH2(I)=BPH(I)
 13   BM2(I)=BMEAN(I)
      DO 14 I=1,NDAT
 14   XPH2(I)=XPH(I)
 10   CONTINUE
C
C     PLOT THETA VERSUS FREQUENCY
C
      IYM=53
      IF(NF/2.GT.100) IYM=NF/2
      CALL PLOT1(TFREQ,THETA,XPH,XB,NF,IYM,0.,0.,1)
      WRITE(16,200)
 200  FORMAT(45X,'THETA STATISTIC VERSUS FREQUENCY')
      STOP
      END

      SUBROUTINE PDM(THETAF)
C
C     CALCULATE PHASE DISPERSION AT FREQUENCY FREQ
C        RETURNS THETAF,BPH(I),BMEAN(I),BS2(I),NBIN
C
      DIMENSION XX(1000),XT(1000),XPH(1000),XPH2(1000),XB(1000)
      DIMENSION BMEAN(101),BS2(101),BPH(101),TIT(20)
      COMMON /X/ XX,XT,XPH,XB,BMEAN,BS2,BPH,XPH2,TIT
      COMMON /N/ NDAT,MODE,NB,NCOV,NF,NDEG,IPUNCH,METHOD,NBIN
     1 ,NSEG,NSN(21)
      COMMON /P/ PERMAX,PERMID,PERMIN,FMIN,FMID,FMAX,DELF,PER,FREQ,
     1   TRANGE,DTBAR,SIG2,AMEAN,PRSIG,PLSIG,TENSE,BNJ,RSIG,YMN,YMX
C
C     SET BIN DIMENSION
      MAXBIN=101
C
 101  FORMAT(5X,12(2X,I8))
 102  FORMAT(5X,12(2X,1PE10.2))
      IF(MODE.EQ.1) WRITE(16,103)
 103  FORMAT(1X,'ENTERING ROUTINE PDM',/)
      THETAF=0.
      BNJ=0.
      NTBN=0
C     SEGMENT LOOP
      DO 20 ISEG=1,NSEG
      ILOW=NSN(ISEG)
      IHGH=NSN(ISEG+1)-1
C     COMPUTE PHASES FOR DATA POINTS
      DO 11 I=ILOW,IHGH
      T1=(XT(I)-XT(ILOW))*FREQ
 11   XPH(I)=T1-AINT(T1)
      THETA0=0.
C     BIN LOOPS
      DP=1./NB
      IBIN=0
      DO 14 ICOV=1,NCOV
      DO 14 IB=1,NB
      NUMB=0
      IF(IBIN.EQ.MAXBIN) GO TO 15
      PHI1=(IB-1.+(ICOV-1.)/NCOV)/NB
      PHI2=PHI1+DP
C     SORT DATA
      DO 12 I=ILOW,IHGH
      IF(XPH(I).GE.PHI1.AND.XPH(I).LT.PHI2) GO TO 13
      IF(PHI2.LE.1..OR.XPH(I).GE.PHI2-1.) GO TO 12
 13   NUMB=NUMB+1
      XB(NUMB)=XX(I)
 12   CONTINUE
      IF(NUMB.EQ.0) GO TO 14
      IBIN=IBIN+1
      BPH(IBIN)=(PHI1+PHI2)/2.
C     COMPUTE MEAN AND S.D. FOR BIN
      CALL VARM(NUMB,XB,S2,UMN)
      IF(MODE.NE.1) GO TO 16
      WRITE(16,101) IBIN,IB,ICOV,NUMB
      WRITE(16,102) FREQ,PHI1,PHI2,UMN,S2,XB(1),XB(NUMB)
 16   CONTINUE
      BS2(IBIN)=S2
      BMEAN(IBIN)=UMN
      THETA0=THETA0+(NUMB-1)*S2
      BNJ=BNJ+1./NUMB
      NTBN=NTBN+1
 14   CONTINUE
      IBIN=IBIN+1
 15   CONTINUE
      BPH(IBIN)=BPH(IBIN-1)-1.
      BS2(IBIN)=S2
      BMEAN(IBIN)=UMN
      NBIN=IBIN
C     WHITTAKER AND ROBINSON METHOD
      IF(METHOD.NE.2) GO TO 17
      NBI1=NBIN-1
      CALL VARM(NBI1,BMEAN,S2MEAN,MNMN)
      THETA0=(NBI1-1.)*S2MEAN
 17   CONTINUE
      IF(MODE.EQ.1) WRITE(16,102) THETA0
      THETAF=THETAF+THETA0
 20   CONTINUE
      THETAF=THETAF/(NDEG*SIG2)
      IF(METHOD.EQ.2) THETAF=1.-THETAF
      BNJ=NTBN/BNJ
      IF(MODE.EQ.1) WRITE(16,102) THETAF,BNJ
      RETURN
      END

      SUBROUTINE VARM(N,X,S2,U)
C
C     SAMPLE VARIANCE AND MEAN,U, OF ARRAY X
C
      DIMENSION X(1)
      IF(N.LE.0) GO TO 2
      A=0.
      B=0.
      DO 1 I=1,N
      A=A+X(I)
      B=B+X(I)**2
 1    CONTINUE
      U=A/N
      IF(N.EQ.1) GO TO 3
      S2=(B-N*U**2)/(N-1)
      RETURN
 2    U=0.
 3    S2=0.
      RETURN
      END

      FUNCTION PCHI(CHI2,F,NDEG,ND2,NT)
C
C     PCHI=SIGNIFICANCE=PROBABILITY THAT A RAMDOM SAMPLE WILL GIVE
C        CHI**2 OR F AS LOW OR LOWER THAN THE GIVEN VALUE
C
C     CALCULATES LOWER AREA UNDER A CHI**2 DISTRIBUTION, GIVEN
C        CHI**2 (CHI2), AND DEGREES OF FREEDOM (NDEG)
C        NT=1, ONE-TAILED (STRAIGHT AREA)
C        NT=2, TWO-TAILED (TWICE THE AREA UNDER THE NEAREST TAIL)
C     USES ABRAMOWITZ AND SEEGUN, 26.4.14,26.2.16, GOOD FOR NDEG.GT.30
C
C     IF CHI2=0, USES F-DISTRIBUTION, NDEG,ND2 DEG. OF FREEDOM
C        REFERENCE...A AND S, 26.6.15
C
      DATA T29,P1,A1,A2,A3,G1/0.22222222,0.33267,0.4361836,-.1201676,
     1   .9372980,.3989423/
C
C     CALCULATE X2
      IF(CHI2.EQ.0.) GO TO 12
      X2=(CHI2/NDEG)**(1./3.) -(1.-T29/NDEG)
      X2=X2/SQRT(T29/NDEG)
C
      GO TO 13
 12   CONTINUE
      F13=F**(1./3.)
      X2=F13*(1.-T29/ND2)-(1.-T29/NDEG)
      X2=X2/SQRT(T29/NDEG+F13**2*T29/ND2)
 13   CONTINUE
C
      IF(X2.GT.0.) GO TO 9
      X2=-X2
      IPOS=0
      IF(X2.GT.10.) GO TO 10
      GO TO 8
 9    CONTINUE
      IPOS=1
      IF(X2.GT.10.) GO TO 11
 8    CONTINUE
C     GAUSSIAN(X2)
      Z2=G1*EXP(-X2**2/2.)
C     NORMAL DISTRIBUTION TAIL AREA(X2)
      T=1./(1.+P1*X2)
      PCHI=Z2*(T*(A1+T*(A2+T*A3)))
      IF(NT.NE.2) GO TO 7
      PCHI=2.*PCHI
      RETURN
 7    CONTINUE
      IF(IPOS.NE.0) PCHI=1.-PCHI
      RETURN
 10   CONTINUE
      PCHI=0.
      RETURN
 11   CONTINUE
      PCHI=1.
      IF(NT.EQ.2) PCHI=0.
      RETURN
      END

      SUBROUTINE DATSUM
C
C     REVIEW TIME-SERIES DATA, USES XPH AND XB AS DUMMIES
C
      DIMENSION XPL(101),YPL(101)
      DIMENSION XX(1000),XT(1000),XPH(1000),XPH2(1000),XB(1000)
      DIMENSION BMEAN(101),BS2(101),BPH(101),TIT(20)
      COMMON /X/ XX,XT,XPH,XB,BMEAN,BS2,BPH,XPH2,TIT
      COMMON /N/ NDAT,MODE,NB,NCOV,NF,NDEG,IPUNCH,METHOD,NBIN
     1 ,NSEG,NSN(21)
C
C     PLOT FIRST 101 DATA POINTS
      NN=MIN0(NDAT,101)
      CALL PLOT1(XT,XX,XPH,XB,NN,53,0.,0.,1)
      WRITE(16,100)
 100  FORMAT(45X,'DATA--FIRST 101 POINTS')
C     PLOT LAST 101 POINTS
      IF(NDAT.LE.101) GO TO 2
      NN=NDAT-101
      CALL PLOT1(XT(NN),XX(NN),XPH,XB,101,53,0.,0.,1)
      WRITE(16,101)
 101  FORMAT(45X,'DATA--LAST 101 POINTS')
 2    CONTINUE
C     TIME COVERAGE
      TRANGE=XT(NDAT)-XT(1)
      DT=TRANGE/101.
      DO 3 I=1,101
      XPL(I)=XT(1)+DT*(I-1)+DT/2.
 3    YPL(I)=0.
      DSML=XX(1)
      DBIG=DSML
      DO 4 I=1,NDAT
      IBIN=101*(XT(I)-XT(1))/TRANGE+1
      IF(I.EQ.NDAT) IBIN=101
      YPL(IBIN)=YPL(IBIN)+1.
      DSML=AMIN1(DSML,XX(I))
 4    DBIG=AMAX1(DBIG,XX(I))
      CALL PLOT1(XPL,YPL,XPH,XB,101,53,0.,0.,1)
      WRITE(16,102)
 102  FORMAT(40X,'TIME COVERAGE, POINTS PER TIME INTERVAL')
C     DATA FREQUENCY PLOT
      DRANGE=DBIG-DSML
      DD=DRANGE/101.
      DO 5 I=1,101
      XPL(I)=DSML+DD*(I-1)+DD/2.
 5    YPL(I)=0.
      DO 6 I=1,NDAT
      IBIN=101*(XX(I)-DSML)/DRANGE+1
      IF(I.EQ.NDAT) IBIN=101
 6    YPL(IBIN)=YPL(IBIN)+1.
      CALL PLOT1(XPL,YPL,XPH,XB,101,53,0.,0.,1)
      WRITE(16,103)
 103  FORMAT(40X,'DATA DISTRIBUTION, POINTS PER DATA INTERVAL')
      RETURN
      END

      SUBROUTINE REDUCE
C
C     REMOVE OSCILLATION WITH FREQUENCY FR FROM DATA
C        UP TO 25 FR'S READ FROM DATA UNTIL ZERO ENCOUNTERED
C        FR IN COLS 1-10, INTEGER FLAG IN COLS 10-20
C             FLAG=0...NORMAL REDUCTION
C             FLAG.LT.0...PUNCH DECK OF BIN MEANS AND PHASES
C             FLAG.GT.0...READ FLAG BIN MEANS FROM DATA
C             FR.LT.0...NO PLOTS, ABS(FR) USED
C     PUNCH DECK OF REDUCED DATA IF IPUNCH.NE.0
C     REDUCTION SUPPRESSED IF LESS SIGNIFICANT THAN RSIG
C
      DIMENSION XPL(2000),YPL(2000),NPL(3)
      DIMENSION XX(1000),XT(1000),XPH(1000),XPH2(1000),XB(1000)
      DIMENSION BMEAN(101),BS2(101),BPH(101),TIT(20)
      COMMON /X/ XX,XT,XPH,XB,BMEAN,BS2,BPH,XPH2,TIT
      COMMON /N/ NDAT,MODE,NB,NCOV,NF,NDEG,IPUNCH,METHOD,NBIN
     1 ,NSEG,NSN(21)
      COMMON /P/ PERMAX,PERMID,PERMIN,FMIN,FMID,FMAX,DELF,PER,FREQ,
     1   TRANGE,DTBAR,SIG2,AMEAN,PRSIG,PLSIG,TENSE,BNJ,RSIG,YMN,YMX
C
      IF(NB.NE.0) GO TO 302
      NB=5
      NCOV=2
 302  CONTINUE
      NDEG=(NDAT-NB)*NCOV
      ND1=NDAT-1
      ND2=NDEG
      CALL VARM(NDAT,XX,SIG20,U)
      SD0=SQRT(SIG20)
      SIG2=SIG20
      NSEG=1
      NSN(1)=1
      NSN(2)=NDAT+1
C
      DO 500 IRED=1,25
      READ(15,108) FR,NNBIN
      IF(FR.EQ.0.) GO TO 501
      IF(IRED.GT.1) GO TO 20
      WRITE(16,21)
 21   FORMAT('0*****DATA REDUCTION*****'//)
      WRITE(16,22) NDAT,U,SD0,SIG20
 22   FORMAT(10X,I5,1X,'POINTS',5X,'MEAN=',1PE12.5,5X,'S.D.=',E12.5,
     1   5X,'VARIANCE=',E12.5//)
      WRITE(16,23) ND1,ND2,RSIG,TENSE
 23   FORMAT(10X,'D.O.F.=',2I5,5X,'REQUIRED SIGNIFICANCE=',E10.3,5X,
     1   'SPLINE TENSION=',1PE10.3//)
      IF(IPUNCH.NE.0) WRITE(16,101)
 101  FORMAT(10X,'A DECK WILL BE PUNCHED, REDUCED DATA'//)
 20   CONTINUE
      WRITE(16,100) IRED,FR,NNBIN
 100  FORMAT('0DATA REDUCTION NUMBER',I3,5X,'FREQUENCY=',1PE15.8,
     1   5X,'REDUCTION FLAG=',I4//)
      IF(NNBIN.LE.0) WRITE(16,1002) NB,NCOV
 1002 FORMAT(10X,'BIN STRUCTURE FOR REDUCTION=',2I5//)
      IPLOT=1
      IF(FR.LT.0) IPLOT=0
      FR=ABS(FR)
C
      FREQ=FR
      CALL PDM(TF)
C
C     READ BIN MEANS FROM CARDS
      IF(NNBIN.LE.0) GO TO 301
      WRITE(16,1003)
 1003 FORMAT(10X,'BIN MEANS AND PHASES READ FROM DATA'//)
      NBIN=NNBIN
      READ(15,107) (BMEAN(I),BPH(I),I=1,NBIN)
      GO TO 31
 301  CONTINUE
C     CHECK SIGNIFICANCE OF MODE
      TFI=1./TF
      DSIG=PCHI(0.,TFI,ND1,ND2,2)
      WRITE(16,30) TF,DSIG
 30   FORMAT(10X,'THETA=',1PE10.3,5X,'SIGNIFICANCE=',E10.3//)
      IF(DSIG.LE.RSIG) GO TO 31
      WRITE(16,32)
 32   FORMAT(10X,'INSIGNIFICANT VARIANCE AT THIS FREQUENCY, REDUCTION SU
     1PPRESSED'//)
      GO TO 500
 31   CONTINUE
      WRITE(16,33) NBIN
 33   FORMAT(10X,'PERIODIC SPLINE UNDER TENSION THROUGH',I3,' POINTS'//)
      IF(NNBIN.LT.0) WRITE(16,1001)
 1001 FORMAT(10X,'A DECK WILL BE PUNCHED, BIN MEANS AND PHASES'//)
      BSM=BS2(1)
      DO 3 I=2,NBIN
 3    BSM=AMAX1(BSM,BS2(I))
      BSM=SQRT(BSM)
      DO 40 I=1,NDAT
      XPL(I)=XPH(I)
 40   YPL(I)=XX(I)
      BMIN=BMEAN(1)
      BMAX=BMIN
      DO 41 I=1,NBIN
      BMIN=AMIN1(BMIN,BMEAN(I))
      BMAX=AMAX1(BMAX,BMEAN(I))
      J=NDAT+I
      XPL(J)=BPH(I)
      IF(XPL(J).LT.0.) XPL(J)=XPL(J)+1.
 41   YPL(J)=BMEAN(I)
      BAMP=BMAX-BMIN
C
C     SORT PHASE POINTS
C
      CALL SORT(NBIN,2,BPH,BMEAN,T1)
      IF(MODE.EQ.1) WRITE(16,200)(BPH(I),I=1,NBIN)
      IF(MODE.EQ.1) WRITE(16,200)(BMEAN(I),I=1,NBIN)
 200  FORMAT(1X,1P10E12.3)
C
C     REDUCE DATA--CUBIC SPLINE UNDER TENSION INTERPOLATION
C
      BMEAN(NBIN)=BMEAN(1)
      CALL CURV1(NBIN,BPH,BMEAN,T1,T2,BS2,XPH2,XB,TENSE)
      BMIN=BMEAN(1)
      BMAX=BMIN
      SMIN=BMIN
      SMAX=BMIN
      DO 10 I=1,NDAT
      IF(XPH(I).GT.BPH(NBIN)) XPH(I)=XPH(I)-1.
      T1=XX(I)
      T2=CURV2(XPH(I),NBIN,BPH,BMEAN,BS2,TENSE,1)
      XX(I)=T1-T2
      XB(I)=T2
      IF(XPH(I).LT.0.) XPH(I)=XPH(I)+1.
      BMIN=AMIN1(BMIN,T1)
      BMAX=AMAX1(BMAX,T1)
      SMIN=AMIN1(SMIN,T2)
      SMAX=AMAX1(SMAX,T2)
      IF(MODE.EQ.1.AND.I.LE.100) WRITE(16,201) I,T1,T2,XX(I)
 201  FORMAT(5X,I5,1P5E15.5)
 10   CONTINUE
      XAMP=BMAX-BMIN
      SAMP=SMAX-SMIN
      BSAMP=BSM*SQRT(2.*NB/NDAT)
      WRITE(16,1005) XAMP,BAMP,SAMP,BSAMP
 1005 FORMAT(10X,'AMPLITUDES...DATA=',1PE12.5,5X,'MEANS=',E12.5,5X,
     1   'SPLINE FIT=',E12.5,5X,'UNCERTAINTY=',E12.5//)
C
C     COMPUTE POST-FIT STATISTICS
C
      SIG2P=SIG2
      CALL VARM(NDAT,XX,SIG2,U)
      VAR1=(SIG2P-SIG2)/SIG20
      VAR2=(1.-TF)*SIG2P/SIG20
      TVAR=1.-SIG2/SIG20
      SD=SQRT(SIG2)
      WRITE(16,50) VAR1,VAR2,TVAR
 50   FORMAT(10X,'FRACTION OF VARIANCE ACCOUNTED FOR...THIS STEP,ACTUAL=
     1',F7.4,3X,'EXPECTED=',F7.4,3X,'...TOTAL SO FAR=',F7.4//)
      WRITE(16,51) SIG2,SD
 51   FORMAT(10X,'REMAINING VARIANCE=',1PE12.5,5X,'STANDARD DEVIATION=',
     1   E12.5//)
C
C     PUNCH MEAN CURVE IF NNBIN.LT.0
C
      IF(NNBIN.GE.0) GO TO 600
      FR=-FR
      WRITE(17,108) FR,NBIN
 108  FORMAT(F10.7,I10)
      WRITE(17,107) (BMEAN(I),BPH(I),I=1,NBIN)
 600  CONTINUE
C
C     PLOT MEAN CURVE
C
      IF(IPLOT.EQ.0) GO TO 500
      NPL(1)=NDAT
      NPL(2)=NBIN
      NPL(3)=101
      DO 42 I=1,101
      J=I+NDAT+NBIN
      XPL(J)=(I-1)/100.
 42   YPL(J)=CURV2(XPL(J),NBIN,BPH,BMEAN,BS2,TENSE,I)
      CALL PLOT1(XPL,YPL,XPL,YPL,NPL,53,YMN,YMX,3)
      WRITE(16,202)
 202  FORMAT(33X,'DATA, BIN MEANS, SPLINE FIT AT REDUCTION FREQUENCY')
C
C     PLOT RESULT
C
      CALL PLOT1(XPH,XX,XPH2,XB,NDAT,53,0.,0.,1)
      WRITE(16,104)
 104  FORMAT(30X,'REDUCED DATA VERSUS PHASE AT REDUCTION FREQUENCY')
 500  CONTINUE
      WRITE(16,502)
 502  FORMAT(1H1)
 501  CONTINUE
C
C     PUNCH DECK OF REDUCED DATA IF IPUNCH.NE.0
C
      IF(IPUNCH.EQ.0) RETURN
      WRITE(17,106) NDAT
 106  FORMAT(I10)
      WRITE(17,107) (XX(I),XT(I),I=1,NDAT)
 107  FORMAT(8F10.5)
      RETURN
      END

      SUBROUTINE SORT(N,M,X1,X2,X3)
C
C     SORT XK(I) ON X1(I), K=1,M...I=1,N
C
      DIMENSION X1(1),X2(1),X3(1)
C
      MMAX=3
      IF(N.LE.0) STOP 88
      IF(M.LE.0.OR.M.GT.MMAX) STOP 89
      DO 3 II=2,N
      GO TO (11,12,13),M
 13   T3=X3(II)
 12   T2=X2(II)
 11   T1=X1(II)
      IIM=II-1
      DO 1 I=1,IIM
      J=II-I
      JP=J+1
      IF(X1(J).LE.T1) GO TO 2
      GO TO (21,22,23),M
 23   X3(JP)=X3(J)
 22   X2(JP)=X2(J)
 21   X1(JP)=X1(J)
 1    CONTINUE
      JP=1
 2    CONTINUE
      GO TO (31,32,33),M
 33   X3(JP)=T3
 32   X2(JP)=T2
 31   X1(JP)=T1
 3    CONTINUE
      RETURN
      END

      SUBROUTINE ZERO
      COMMON /N/ NN(31)
      COMMON /P/ PP(20)
      IN=31
      IP=20
      DO 1 I=1,IN
 1    NN(I)=0
      DO 2 I=1,IP
 2    PP(I)=0.
      RETURN
      END

      SUBROUTINE PLOT1(X,Y,IX,IY,NDAT,IYMAZ,YS1,YL1,NUM)
C
C     SINGLE PRECISION VERSION
C
C     PLOT NUM CURVES AT POINTS (X,Y), CURVES STORED CONSECUTIVELY
C     NDAT(I)=NUMBER OF POINTS IN CURVE I
C     N-TH CURVE PLOTTED WITH SYMBOL AC(N)
C     CALL WITH IX==X, IY==Y...DUMMIES
C        BUT DIMENSION SEPARATELY IF X OR Y IS NEEDED LATER
C     DIMENSION NDAT(NUM), NOT NEEDED IF NUM=1
C     IYMAX= NUMBER OF ACTUAL LINES PRINTED MINUS ONE
C     YS1,YL1=LOWER AND UPPER VALUES ON Y-AXIS (COMPUTED IF EQUAL)
C     SWITCH AXES IF IYMAX.GT.100
C
      DIMENSION X(1),Y(1),IX(1),IY(1),NDAT(1),ZX(11),AFX(101),AC(50)
      DATA BLX/2H X/,AC/1H*,1H+,1HX,1H.,1H0,1H*,1H+,1HX,1H.,1H0,39*1H*,
     1 1HQ/
      NDATA=0
      DO 30 I=1,NUM
 30   NDATA=NDATA+NDAT(I)
      IYMAX=IYMAZ
      IF(IYMAX.EQ.0) IYMAX=1
      YS=YS1
      YL=YL1
      IF(YS.NE.YL) GO TO 500
      YL=Y(1)
      YS=Y(1)
      DO 501 I=1,NDATA
      YL=AMAX1(YL,Y(I))
 501  YS=AMIN1(YS,Y(I))
 500  CONTINUE
      XL = X(1)
      XS = X(1)
      DO 502 I = 1,NDATA
      XL = AMAX1(XL,X(I))
      XS = AMIN1(XS,X(I))
 502  CONTINUE
      XW=AMAX0(100,IYMAX)
      YW=AMIN0(100,IYMAX)
      XSCALE=(XL-XS)/XW
 503  YSCALE=(YL-YS)/YW
      IF(YSCALE.NE.0) GO TO 3000
      YSCALE = 1.0
      IYMAX = 0
3000  CONTINUE
      IF(XSCALE.NE.0.) GO TO 3001
      WRITE(16,3002)
 3002 FORMAT('0DEGENERATE ABCISSA ENCOUNTERED IN PLOT1')
      RETURN
 3001 CONTINUE
      J = 0
      DO 105 I = 1,NDATA
104   J = J+1
      IX(J) = (X(I) -XS)/XSCALE+0.5
      IY(J) = (Y(I)-YS)/YSCALE+0.5
C        SWITCH AXES FOR LONG PLOT
      IF(IYMAX.LE.100) GO TO 105
      IT1=IX(J)
      IX(J)=IY(J)
      IY(J)=IT1
 105  CONTINUE
      IF(IYMAX.LE.100) GO TO 106
      T1=YS
      YS=XS
      XS=T1
      T1=YSCALE
      YSCALE=XSCALE
      XSCALE=T1
 106  CONTINUE
1     FORMAT(1H1)
2     FORMAT( 2X,  10H Y VALUES 3X, 1HI20(5H....I))
4     FORMAT(1H , 1PE13.6,     1HI101A1,1HI)
6     FORMAT(15X, 1HI20(5H....I))
7     FORMAT(6X,1PE13.6,5(7X,1PE13.6)/9X,5(7X,1PE13.6))
8     FORMAT(     31X, 9H YSCALE = 1PE15.7, 6X, 8HXSCALE = 1PE15.7)
504   WRITE (16,1)
505   WRITE (16,2)
      IF(IYMAX.GT.100) GO TO 11
9     LL=IYMAX
      GO TO 13
10    LL=LL-1
      GO TO 13
11    LL=0
      GO TO 13
12    LL=LL+1
13    DO 14 I=1,101
14    AFX(I)=BLX
      J=0
      DO 16 NCURVE=1,NUM
      JMAX=NDAT(NCURVE)
      DO 16 K=1,JMAX
      J=J+1
      IF (IY(J).NE.LL) GO TO 16
15    II=IX(J)+1
      IF(II.LE.0.OR.II.GT.101) GO TO 16
      IF(AFX(II).NE.BLX.AND.AFX(II).NE.AC(NCURVE)) GO TO 400
      AFX(II)=AC(NCURVE)
      GO TO 16
 400  AFX(II)=AC(50)
16    CONTINUE
506   ZY = FLOAT(LL)*YSCALE+YS
      WRITE (16,4) ZY, (AFX(I), I=1,101)
      IF (IYMAX.GT.100) GO TO 18
17    IF(LL) 19,19,10
18    IF (LL.LT.IYMAX) GO TO 12
19    WRITE (16,6)
      DO 20 K = 1,11
20    ZX(K) = 10.*FLOAT(K-1)*XSCALE+XS
      WRITE (16,7) (ZX(K), K = 1,11,2), (ZX(K), K = 2,10,2)
      WRITE (16,8) YSCALE, XSCALE
      RETURN
      END
