      subroutine ndata

*-----standard data read setup

      dimension tt(5),tx(5)
      dimension xx(1000),xt(1000),xph(1000),xph2(1000),xb(1000)
      dimension bmean(101),bs2(101),bph(101),tit(20)
      common /x/ xx,xt,xph,xb,bmean,bs2,bph,xph2,tit
      common /n/ ndat,mode,nb,ncov,nf,ndeg,ipunch,nbin
     1 ,nseg,nsn(21)
      common /p/ permax,permid,permin,fmin,fmid,fmax,delf,per,freq,
     1   trange,dtbar,sig2,amean,prsig,plsig,tense,bnj,rsig,ymn,ymx

      mode = 2

 100  format(i10)
 101  format(8f10.0)
      read(15,100) ndat
      j = 0
      ncard = 4
      do 14 ii = 1,ndat
        read(15,101) (tt(i),tx(i),i = 1,ncard)
        do 15 i = 1,ncard
          if(tt(i).lt..01) go to 15
          j = j+1
          xt(j) = tt(i)
          xx(j) = tx(i)
 15     continue
 14   continue
      ndat = j

*-----data select-take ndat points, starting with point ifrst
      ndat = ndat
      ifrst = 1
      do 2 i = 1,ndat
        xx(i) = xx(i+ifrst-1)
        xt(i) = xt(i+ifrst-1)
 2    continue
*------------------------
      do 1 i = 1,ndat
        xx(i) = -xx(i)
 1    continue
*------------------------
      return

      entry segset
*------------------------
      nseg = 4
      xph(1) = 38000.
      xph(2) = 40000.
      xph(3) = 43200.
*------------------------
      return

      entry reset
      return
      end

***********pdm**********pdm**********pdm**********pdm**********

*-----period analysis via phase dispersion minimization
*       version 2, stellingwerf, rutgers,1979
*       vax/vms version, mrc, 1981
*       fortran 77 version, mrc, 1988
*
*     mode = 1..debug, mode = 2..rough cut, mode = 3..fine scan
*        if mode = 4..no default values are set
*        maximize mean curve amplitude
*     multiple data reduction
*        frequencies read by reduce from cards
*        set ipunch = 1 to punch reduced data
*     for segmental averaging set nseg = number of segments
*        also set xph(i) = starting time of segment i+1
*-----user supplied routines..ndata,reset,segset

      dimension xx(1000),xt(1000),xph(1000),xph2(1000),xb(1000)
      dimension bmean(101),bs2(101),bph(101),tit(20)
      dimension theta(500),tfreq(500),bm2(101),bph2(101)
      common /x/ xx,xt,xph,xb,bmean,bs2,bph,xph2,tit
      common /n/ ndat,mode,nb,ncov,nf,ndeg,ipunch,nbin
     1 ,nseg,nsn(21)
      common /p/ permax,permid,permin,fmin,fmid,fmax,delf,per,freq,
     1   trange,dtbar,sig2,amean,prsig,plsig,tense,bnj,rsig,ymn,ymx

*-----namelist /param/ fmin,permax,fmid,permid,fmax,permin,nf,delf,
*    1   nb,ncov,prsig,plsig,ffmin,ffmid,ffmax

*-----read title

 105  format(20a4)
      read(15,105) (tit(i),i = 1,20)

 100  format(1x,44('pdm'))
 99   format(1h1)
      write(16,99)
      write(16,100)
      write(16,100)
      write(16,100)

*-----set dimensions
      maxx = 1000
      maxf = 500
      maxbin = 101
      maxseg = 20
*-----zero common blocks
      call zero
      tense = 1.
      rsig = 0.5

*-----set data-xx,xt,ndat,mode

      call ndata
      if(ndat.le.0.or.ndat.gt.maxx) mode = 1

*-----sort data
      call sort( ndat,2,xt,xx,t1 )

*-----data reduction
      call reduce

*-----set segments if desired..nseg, put tseg in xph
*        tseg(i) = time value separating seg(i) and seg(i+1)
      call segset

      if(nseg.eq.0) nseg = 1
      if(nseg.gt.maxseg) nseg = maxseg
      nsn(1) = 1
      nsn(nseg+1) = ndat+1
      if(nseg.eq.1) go to 4
        iseg = 2
        do 3 i = 2,ndat
          if(xt(i).lt.xph(iseg-1)) go to 3
          nsn(iseg) = i
          iseg = iseg+1
          if(iseg.gt.nseg) go to 4
 3      continue
 4    continue
 101  format(1x,13(2x,i8))
 102  format(1x,1p13e10.2)
 103  format('0sorted data...n',8x,'t',14x,'x'/)
 104  format(12x,i5,1p2d15.6)
      if(mode.eq.1) then
        write(16,101) ndat,mode,nseg,(nsn(i),i = 1,nseg)
        write(16,103)
        do 6 i = 1,ndat
          write(16,104) i,xt(i),xx(i)
 6      continue
      endif
*-----overall data review, debug only
      if(mode.eq.1)  call datsum

*-----compute time statistics, points must be well ordered
      trange = 0.
      dtbar = 0.
      sig2 = 0.
      amean = 0.
      do 2 iseg = 1,nseg
        n1 = nsn(iseg)+1
        n2 = nsn(iseg+1)-1
        dt = xt(n1)-xt(n1-1)
        dt1 = dt
        dt2 = dt
        do 1 i = n1,n2
          dt = xt(i)-xt(i-1)
          dt1 = amin1(dt1,dt)
          dt2 = amax1(dt2,dt)
1       continue
        tr = xt(n2)-xt(n1-1)
        nss = n2-n1+1
        dtbar = tr/nss+dtbar
        trange = amax1(trange,tr)
        call varm( nss,xx(n1),sigs,ameans )
        sig2 = sig2+(nss-1)*sigs
        amean = amean+nss*ameans
 2    continue
      dtbar = dtbar/nseg
      sig2 = sig2/(ndat-nseg)
      amean = amean/ndat
      if(mode.eq.1)  write(16,102) dtbar,trange,sig,sig2,amean

*-----set defaults

      ffmax = 1./(2.*dtbar)
      ffmin = 1./trange
      ffmid = (ffmax+ffmin)/2.
      if(mode.le.1) then
*-------debug--twenty points,midrange,low resolution
        fmid = ffmid
        nf = 20
        delf = 1./(5.*trange)
      else if(mode.eq.2) then
*-------rough cut--500 points, full range, low resolution
        delf = 1./(5.*trange)
        nff = (ffmax-ffmin)/delf
        nf = 500
        if(nff.le.1000) fmin = ffmin
        if(nff.gt.1000) fmid = ffmid
      else if(mode.eq.3) then
*-------fine scan--201 points,high resolution,set fmid or permid in res
        nf = 201
        delf = 1./(100.*trange)
      endif

*-----standard bin structure--10 bins,double cover = (5,2)
      nb = 5
      ncov = 2

*-----output parameters
      prsig = 0.50
      plsig = 0.05
      if(mode.eq.3) plsig = -1.0
      if(mode.eq.1) write(16,*) fmin,permax,fmid,permid,fmax,permin
     1  ,nf,delf,nb,ncov,plsig,ffmin,ffmid,ffmax

*-----use reset to adjust parameters
      call reset
      if(mode.eq.1) write(16,*) fmin,permax,fmid,permid,fmax,permin
     1  ,nf,delf,nb,ncov,plsig,ffmin,ffmid,ffmax

*-----now generate fmin,delf,nf from given parameters

      if(permax.ne.0.)  fmin = 1./permax
      if(permid.ne.0.)  fmid = 1./permid
      if(permin.ne.0.)  fmax = 1./permin
      if(nf*delf.ne.0.) then
*-------nf and delf both set
        if(fmin.ne.0.)  go to 30
        if(fmax.ne.0.)  fmin = fmax-nf*delf
        if(fmid.ne.0.)  fmin = fmid-nf*delf/2.
        go to 30
      endif
*-----two frequencies specified, set fmin and fmax
      if(fmin.eq.0.)  fmin = fmid*2-fmax
      fmin = amax1(fmin,ffmin)
      if(fmax.eq.0.)  fmax = 2.*fmid-fmin
      if(fmax.le.fmin)  stop 11
      if(nf.ne.0) then
*-------delf specified
        if(delf.eq.0)  stop 10
        nf = (fmax-fmin)/delf
      else
*-------nf specified
        delf = (fmax-fmin)/nf
      endif
 30   continue
      if(mode.eq.1)  write(16,*) fmin,permax,fmid,permid,fmax,permin
     1  ,nf,delf,nb,ncov,plsig,ffmin,ffmid,ffma

*--------checks
      if(mode.eq.1)  nf = 20
      nf = min0(nf,maxf)
      if(nb*ncov.eq.0) stop 12
      fmin = amax1(fmin,ffmin)

*-----degrees of freedom for chi**2
      ndeg = (ndat-nb*nseg)*ncov

*-----degrees of freedom for f-test
      ndf1 = ndat-nseg
      ndf2 = ndeg

*-----print header

      sig = sqrt(sig2)
 300  format(1h0)
 301  format(////)
      write(16,300)
      write(16,302)
 302  format(30x,'spectral analysis using phase dispersion minimization,
     1 version 2 - 1979')
      write(16,300)
      write(16,322) tit
 322  format(25x,20a4)
      write(16,301)
      write(16,303) mode
 303  format(5x,'calculation mode = ',i2,'...')
      go to(41,42,43,44),mode
 41   write(16,304)
      go to 45
 42   write(16,305)
      go to 45
 43   write(16,306)
      go to 45
 44   continue
      write(16,299)
 45   continue
 304  format(1h+,27x,'debug')
 305  format(1h+,27x,'rough cut')
 306  format(1h+,27x,'fine scan')
 299  format(1h+,27x,'all parameters set by reset')
      write(16,307) ndat
 307  format(1h0,4x,'number of data points = ',i5/)
      if(nseg.eq.1) go to 60
      write(16,601) nseg
 601  format(5x,'segmental averaging in effect,',i3,' segments')
      write(16,602)
 602  format(10x,'seg number     start point     start time')
      do 61 i = 1,nseg
      n2 = nsn(i)
 61   write(16,603) i,n2,xt(n2)
 603  format(14x,i3,10x,i5,9x,1pe10.3)
      write(16,300)
 60   continue
      write(16,308)  xt(1),xt(ndat),trange
 308  format(5x,'time range',5x,1pe10.3,2x,'to',e10.3,5x,'total = ',e10.3)
      write(16,309) dt1,dt2,dtbar
 309  format(5x,'timestep range ',1pe10.3,2x,'to',e10.3,6x,'mean = ',e10.3
     1)
      write(16,310) amean,sig,sig2
 310  format(1h0,4x,'mean data value = ',1pe10.3,4x,'standard deviation = ',
     1   e10.3,4x,'variance = ',e10.3//)
      write(16,311)
 311  format(1x,'final parameter values, zero if unspecified'/)
      write(16,312) fmin,permax
 312  format(5x,'minimum frequency = ',1pe10.3,'  maximum period = ',e10.3)
      write(16,313) fmid,permid
 313  format(5x,'mean frequency = ',3x,1pe10.3,'  mean period = ',3x,e10.3)
      write(16,314) fmax,permin
 314  format(5x,'maximum frequency = ',1pe10.3,'  minimum period = ',e10.3)
      write(16,315) delf,nf
 315  format(5x,'frequency step = ',3x,1pe10.3,'  number of trial frequenc
     1ies = ',i5/)
      write(16,316) nb,ncov
 316  format(5x,'number of bins in cover = ',i4,4x,'number of covers = ',i2/
     1//)
      write(16,317)
 317  format(1x,'statistical information and controls'/)
      write(16,318) ndeg,ndf1,ndf2
 318  format(5x,'degrees of freedom for chi-square = ',i5,6x,
     1          'degrees of freedom for f-test = ',i5,',',i5/)
      write(16,319) prsig,plsig
 319  format(5x,'maximum significance for print or plot at minimum = ',
     1   f7.4,',',f7.4)
      write(16,99)
      write(16,321)
 321  format(1x,32('*'),'list of significant theta minima',32('*'),//)

*-----begin calculation

      nplt = 0
      nmin = 0
      ihead = 1
      do 10 if = 1,nf
        freq = fmin+(if-1)*delf
        call pdm( thetaf )
        theta(if) = thetaf
        tfreq(if) = freq

*-------check for minimum
        if(if.eq.nf.and.theta(if).lt.theta(if-1)) go to 15
        if(if.eq.2.and.theta(2).gt.theta(1)) go to 15
        if(if.lt.3) go to 11
        if(theta(if).lt.theta(if-1).or.theta(if-2).lt.theta(if-1))go to 11
 15     continue
        frem = freq-delf

*-------minimum found, check significance
        nmin = nmin+1
        chi2 = ndeg*theta(if-1)
        nj = bnj
        f = ndeg/chi2
        z = 0.
        sigm = pchi(z,f,ndf1,ndf2,2)
        if(f.lt.1) sigm = 1.
        if(sigm.gt.prsig) go to 11
        per = 1./frem
        if(ihead.ne.0) write(16,320)
 320    format(1x,'imin',8x,'frequency',7x,'period',10x,'theta',6x,
     1  'sigificance',9x,'f',11x,'chi**2'/)
        write(16,400) nmin,frem,per,theta(if-1),sigm,f,chi2
 400    format(1x,i4,3x,1p6e15.5)
        ihead = 0
        if(sigm.gt.plsig) go to 11
        nplt = nplt+1
        if(nplt.gt.20) plsig = -1.
        iym = 53

*-------note...first segment data plotted...
*------------last segment mean curve plotted, may not agree
        nddd = nsn(2)-1
        if(nddd.ge.505) iym = nddd/5.
        call plot1( xph2,xx,xph2,xb,nddd,iym,0.,0.,1 )
        write(16,401) nmin
 401    format(40x,'data versus phase at theta minimum number',i4)
 12     call plot1( bph2,bm2,bph2,bm2,nbin2,53,0.,0.,1 )
        write(16,402) nmin
 402    format(35x,'mean curve versus phase at theta minimum number',i4)
        ihead = 1
 11     continue
        nbin2 = nbin
        do 13 i = 1,nbin
        bph2(i) = bph(i)
 13     bm2(i) = bmean(i)
        do 14 i = 1,ndat
          xph2(i) = xph(i)
 14     continue
 10   continue

*-----plot theta versus frequency

      iym = 53
      if(nf/2.gt.100) iym = nf/2
      call plot1( tfreq,theta,xph,xb,nf,iym,0.,0.,1 )
      write(16,200)
 200  format(45x,'theta statistic versus frequency')
      stop
      end

*-------------------------------------------------------------------------
      subroutine pdm(thetaf)

*-----calculate phase dispersion at frequency freq
*--------returns thetaf,bph(i),bmean(i),bs2(i),nbin

      dimension xx(1000),xt(1000),xph(1000),xph2(1000),xb(1000)
      dimension bmean(101),bs2(101),bph(101),tit(20)
      common /x/ xx,xt,xph,xb,bmean,bs2,bph,xph2,tit
      common /n/ ndat,mode,nb,ncov,nf,ndeg,ipunch,nbin
     1 ,nseg,nsn(21)
      common /p/ permax,permid,permin,fmin,fmid,fmax,delf,per,freq,
     1   trange,dtbar,sig2,amean,prsig,plsig,tense,bnj,rsig,ymn,ymx

*-----set bin dimension
      maxbin = 101

 101  format(5x,12(2x,i8))
 102  format(5x,12(2x,1pe10.2))
      if(mode.eq.1) write(16,103)
 103  format(1x,'entering routine pdm',/)
      thetaf = 0.
      bnj = 0.
      ntbn = 0
*-----segment loop
      do 20 iseg = 1,nseg
        ilow = nsn(iseg)
        ihgh = nsn(iseg+1)-1
*-------compute phases for data points
        do 11 i = ilow,ihgh
          t1 = (xt(i)-xt(ilow))*freq
          xph(i) = t1-aint(t1)
 11     continue
        theta0 = 0.
*-------bin loops
        dp = 1./nb
        ibin = 0
        do 16 icov = 1,ncov
          do 14 ib = 1,nb
            numb = 0
            if(ibin.eq.maxbin) go to 15
            phi1 = (ib-1.+(icov-1.)/ncov)/nb
            phi2 = phi1+dp
*-----------sort data
            do 12 i = ilow,ihgh
              if(xph(i).ge.phi1.and.xph(i).lt.phi2) go to 13
              if(phi2.le.1..or.xph(i).ge.phi2-1.) go to 12
 13           numb = numb+1
              xb(numb) = xx(i)
 12         continue
            if(numb.ne.0) then
              ibin = ibin+1
              bph(ibin) = (phi1+phi2)/2.
*-------------compute mean and s.d. for bin
              call varm( numb,xb,s2,umn )
              if(mode.eq.1) then
                write(16,101) ibin,ib,icov,numb
                write(16,102) freq,phi1,phi2,umn,s2,xb(1),xb(numb)
              end if
              bs2(ibin) = s2
              bmean(ibin) = umn
              theta0 = theta0+(numb-1)*s2
              bnj = bnj+1./numb
              ntbn = ntbn+1
            endif
 14       continue
 16     continue
        ibin = ibin+1
 15     continue
        bph(ibin) = bph(ibin-1)-1.
        bs2(ibin) = s2
        bmean(ibin) = umn
        nbin = ibin
        if(mode.eq.1) write(16,102) theta0
        thetaf = thetaf+theta0
 20   continue
      thetaf = thetaf/(ndeg*sig2)
      bnj = ntbn/bnj
      if(mode.eq.1) write(16,102) thetaf,bnj
      return
      end

*-------------------------------------------------------------------------

      subroutine varm(n,x,s2,u)

*-----sample variance and mean,u, of array x

      dimension x(1)
      if(n.gt.0) then 
        a = 0.
        b = 0.
        do 1 i = 1,n
          a = a+x(i)
          b = b+x(i)**2
 1      continue
        u = a/n
        if(n.eq.1) then
          s2 = 0.
        else
          s2 = (b-n*u**2)/(n-1)
        end if
        return
      end if
*----error condition
      u = 0.
      s2 = 0.
      return
      end

*-------------------------------------------------------------------------

      function pchi(chi2,f,ndeg,nd2,nt)

*-----pchi = significance = probability that a ramdom sample will give
*        chi**2 or f as low or lower than the given value

*     calculates lower area under a chi**2 distribution, given
*        chi**2 (chi2), and degrees of freedom (ndeg)
*        nt = 1, one tailed (straight area)
*        nt = 2, two tailed (twice the area under the nearest tail)
*     uses abramowitz and seegun, 26.4.14,26.2.16, good for ndeg.gt.30

*     if chi2 = 0, uses f distribution, ndeg,nd2 deg. of freedom
*--------reference...a and s, 26.6.15

      data t29,p1,a1,a2,a3,g1/0.22222222,0.33267,0.4361836,-.1201676,
     1   .9372980,.3989423/

*-----calculate x2
      if(chi2.ne.0.) then
        x2 = (chi2/ndeg)**(1./3.) -(1.-t29/ndeg)
        x2 = x2/sqrt(t29/ndeg)
      else
        f13 = f**(1./3.)
        x2 = f13*(1.-t29/nd2)-(1.-t29/ndeg)
        x2 = x2/sqrt(t29/ndeg+f13**2*t29/nd2)
      end if

      if(x2.le.0.) then
        x2 = -x2
        ipos = 0
        if(x2.gt.10.) go to 10
      else
        ipos = 1
        if(x2.gt.10.) go to 11
      end if

*-----gaussian(x2)
      z2 = g1*exp(-x2**2/2.)
*-----normal distribution tail area(x2)
      t = 1./(1.+p1*x2)
      pchi = z2*(t*(a1+t*(a2+t*a3)))
      if(nt.ne.2) go to 7
      pchi = 2.*pchi
      return

 7    continue
      if(ipos.ne.0) pchi = 1.-pchi
      return

 10   continue
      pchi = 0.
      return

 11   continue
      pchi = 1.
      if(nt.eq.2) pchi = 0.
      return
      end

*-------------------------------------------------------------------------

      subroutine datsum

*-----review time-series data, uses xph and xb as dummies

      dimension xpl(101),ypl(101)
      dimension xx(1000),xt(1000),xph(1000),xph2(1000),xb(1000)
      dimension bmean(101),bs2(101),bph(101),tit(20)
      common /x/ xx,xt,xph,xb,bmean,bs2,bph,xph2,tit
      common /n/ ndat,mode,nb,ncov,nf,ndeg,ipunch,nbin
     1 ,nseg,nsn(21)

*-----plot first 101 data points
      nn = min0(ndat,101)
      call plot1( xt,xx,xph,xb,nn,53,0.,0.,1 )
      write(16,100)
 100  format(45x,'data--first 101 points')
*-----plot last 101 points
      if(ndat.le.101) go to 2
      nn = ndat-101
      call plot1( xt(nn),xx(nn),xph,xb,101,53,0.,0.,1 )
      write(16,101)
 101  format(45x,'data--last 101 points')
 2    continue
*-----time coverage
      trange = xt(ndat)-xt(1)
      dt = trange/101.
      do 3 i = 1,101
        xpl(i) = xt(1)+dt*(i-1)+dt/2.
        ypl(i) = 0.
 3    continue
      dsml = xx(1)
      dbig = dsml
      do 4 i = 1,ndat
        ibin = 101*(xt(i)-xt(1))/trange+1
        if(i.eq.ndat) ibin = 101
        ypl(ibin) = ypl(ibin)+1.
        dsml = amin1(dsml,xx(i))
        dbig = amax1(dbig,xx(i))
 4    continue
      call plot1( xpl,ypl,xph,xb,101,53,0.,0.,1 )
      write(16,102)
 102  format(40x,'time coverage, points per time interval')
*-----data frequency plot
      drange = dbig-dsml
      dd = drange/101.
      do 5 i = 1,101
        xpl(i) = dsml+dd*(i-1)+dd/2.
        ypl(i) = 0.
 5    continue
      do 6 i = 1,ndat
        ibin = 101*(xx(i)-dsml)/drange+1
        if(i.eq.ndat) ibin = 101
        ypl(ibin) = ypl(ibin)+1.
 6    continue
      call plot1( xpl,ypl,xph,xb,101,53,0.,0.,1 )
      write(16,103)
 103  format(40x,'data distribution, points per data interval')
      return
      end

*-------------------------------------------------------------------------

      subroutine reduce

*-----remove oscillation with frequency fr from data
*--------up to 25 fr's read from data until zero encountered
*--------fr in cols 1-10, integer flag in cols 10-20
*--------     flag = 0...normal reduction
*--------     flag.lt.0...punch deck of bin means and phases
*--------     flag.gt.0...read flag bin means from data
*--------     fr.lt.0...no plots, abs(fr) used
*-----punch deck of reduced data if ipunch.ne.0
*-----reduction suppressed if less significant than rsig

      dimension xpl(2000),ypl(2000),npl(3)
      dimension xx(1000),xt(1000),xph(1000),xph2(1000),xb(1000)
      dimension bmean(101),bs2(101),bph(101),tit(20)
      common /x/ xx,xt,xph,xb,bmean,bs2,bph,xph2,tit
      common /n/ ndat,mode,nb,ncov,nf,ndeg,ipunch,nbin
     1 ,nseg,nsn(21)
      common /p/ permax,permid,permin,fmin,fmid,fmax,delf,per,freq,
     1   trange,dtbar,sig2,amean,prsig,plsig,tense,bnj,rsig,ymn,ymx

      if(nb.ne.0) go to 302
      nb = 5
      ncov = 2
 302  continue
      ndeg = (ndat-nb)*ncov
      nd1 = ndat-1
      nd2 = ndeg
      call varm( ndat,xx,sig20,u )
      sd0 = sqrt(sig20)
      sig2 = sig20
      nseg = 1
      nsn(1) = 1
      nsn(2) = ndat+1

      do 500 ired = 1,25
        read(15,108) fr,nnbin
        if(fr.eq.0.) go to 501
        if(ired.gt.1) go to 20
        write(16,21)
 21     format('0*****data reduction*****'//)
        write(16,22) ndat,u,sd0,sig20
 22     format(10x,i5,1x,'points',5x,'mean = ',1pe12.5,5x,'s.d. = ',e12.5,
     1    5x,'variance = ',e12.5//)
        write(16,23) nd1,nd2,rsig,tense
 23     format(10x,'d.o.f. = ',2i5,5x,'required significance = ',e10.3,5x,
     1   'spline tension = ',1pe10.3//)
        if(ipunch.ne.0) write(16,101)
 101    format(10x,'a deck will be punched, reduced data'//)
 20     continue
        write(16,100) ired,fr,nnbin
 100    format('0data reduction number',i3,5x,'frequency = ',1pe15.8,
     1    5x,'reduction flag = ',i4//)
        if(nnbin.le.0) write(16,1002) nb,ncov
 1002   format(10x,'bin structure for reduction = ',2i5//)
        iplot = 1
        if(fr.lt.0) iplot = 0
        fr = abs(fr)

        freq = fr
        call pdm( tf )

*-------read bin means from cards
        if(nnbin.le.0) go to 301
        write(16,1003)
 1003   format(10x,'bin means and phases read from data'//)
        nbin = nnbin
        read(15,107) (bmean(i),bph(i),i = 1,nbin)
        go to 31
 301    continue
*-------check significance of mode
        tfi = 1./tf
        dsig = pchi(0.,tfi,nd1,nd2,2)
        write(16,30) tf,dsig
 30     format(10x,'theta = ',1pe10.3,5x,'significance = ',e10.3//)
        if(dsig.le.rsig) go to 31
        write(16,32)
 32     format(10x,'insignificant variance at this frequency'//)
        go to 500
 31     continue
        write(16,33) nbin
 33     format(10x,'periodic spline under tension through',i3,' points'//)
        if(nnbin.lt.0) write(16,1001)
 1001   format(10x,'a deck will be punched, bin means and phases'//)
        bsm = bs2(1)
        do 3 i = 2,nbin
          bsm = amax1(bsm,bs2(i))
 3      continue
        bsm = sqrt(bsm)
        do 40 i = 1,ndat
          xpl(i) = xph(i)
          ypl(i) = xx(i)
 40     continue
        bmin = bmean(1)
        bmax = bmin
        do 41 i = 1,nbin
          bmin = amin1(bmin,bmean(i))
          bmax = amax1(bmax,bmean(i))
          j = ndat+i
          xpl(j) = bph(i)
          if(xpl(j).lt.0.) xpl(j) = xpl(j)+1.
          ypl(j) = bmean(i)
  41    continue
        bamp = bmax-bmin

*-------sort phase points

        call sort( nbin,2,bph,bmean,t1 )
        if(mode.eq.1) write(16,200)(bph(i),i = 1,nbin)
        if(mode.eq.1) write(16,200)(bmean(i),i = 1,nbin)
 200    format(1x,1p10e12.3)

*-------reduce data--cubic spline under tension interpolation

        bmean(nbin) = bmean(1)
        call curv1( nbin,bph,bmean,t1,t2,bs2,xph2,xb,tense )
        bmin = bmean(1)
        bmax = bmin
        smin = bmin
        smax = bmin
        do 10 i = 1,ndat
          if(xph(i).gt.bph(nbin)) xph(i) = xph(i)-1.
          t1 = xx(i)
          t2 = curv2(xph(i),nbin,bph,bmean,bs2,tense,1)
          xx(i) = t1-t2
          xb(i) = t2
          if(xph(i).lt.0.) xph(i) = xph(i)+1.
          bmin = amin1(bmin,t1)
          bmax = amax1(bmax,t1)
          smin = amin1(smin,t2)
          smax = amax1(smax,t2)
          if(mode.eq.1.and.i.le.100) write(16,201) i,t1,t2,xx(i)
 201      format(5x,i5,1p5e15.5)
 10     continue
        xamp = bmax-bmin
        samp = smax-smin
        bsamp = bsm*sqrt(2.*nb/ndat)
        write(16,1005) xamp,bamp,samp,bsamp
 1005   format(10x,'amplitudes...data = ',1pe12.5,5x,'means = ',e12.5,5x
     1   , 'spline fit = ',e12.5,5x,'uncertainty = ',e12.5//)

*-------compute post-fit statistics

        sig2p = sig2
        call varm( ndat,xx,sig2,u )
        var1 = (sig2p-sig2)/sig20
        var2 = (1.-tf)*sig2p/sig20
        tvar = 1.-sig2/sig20
        sd = sqrt(sig2)
        write(16,50) var1,var2,tvar
 50     format(10x,'fraction of variance accounted, this step,actual ='
     1    ,f7.4,3x,'expected = ',f7.4,3x,'...total so far = ',f7.4//)    
        write(16,51) sig2,sd
 51     format(10x,'remaining variance = ',1pe12.5,5x,
     1    'standard deviation = ',e12.5//)

*-------punch mean curve if nnbin.lt.0

        if(nnbin.ge.0) go to 600
        fr = -fr
        write(17,108) fr,nbin
 108    format(f10.7,i10)
        write(17,107) (bmean(i),bph(i),i = 1,nbin)
 600    continue

*-------plot mean curve

        if(iplot.eq.0) go to 500
        npl(1) = ndat
        npl(2) = nbin
        npl(3) = 101
        do 42 i = 1,101
          j = i+ndat+nbin
          xpl(j) = (i-1)/100.
          ypl(j) = curv2(xpl(j),nbin,bph,bmean,bs2,tense,i)
 42     continue
        call plot1( xpl,ypl,xpl,ypl,npl,53,ymn,ymx,3 )
        write(16,202)
 202    format(33x,'data, bin means, spline fit at reduction frequency')

*-------plot result

        call plot1( xph,xx,xph2,xb,ndat,53,0.,0.,1 )
        write(16,104)
 104    format(30x,'reduced data versus phase at reduction frequency')
 500  continue
      write(16,502)
 502  format(1h1)
 501  continue

*-----punch deck of reduced data if ipunch.ne.0

      if(ipunch.eq.0) return
      write(17,106) ndat
 106  format(i10)
      write(17,107) (xx(i),xt(i),i = 1,ndat)
 107  format(8f10.5)
      return
      end

*-------------------------------------------------------------------------

      subroutine sort(n,m,x1,x2,x3)

*-----sort xk(i) on x1(i), k = 1,m...i = 1,n

      dimension x1(1),x2(1),x3(1)

      mmax = 3
      if(n.le.0) stop 88
      if(m.le.0.or.m.gt.mmax) stop 89
      do 3 ii = 2,n
        go to (11,12,13),m
 13     t3 = x3(ii)
 12     t2 = x2(ii)
 11     t1 = x1(ii)
        iim = ii-1
        do 1 i = 1,iim
          j = ii-i
          jp = j+1
          if(x1(j).le.t1) go to 2
          go to (21,22,23),m
 23       x3(jp) = x3(j)
 22       x2(jp) = x2(j)
 21       x1(jp) = x1(j)
 1      continue
        jp = 1
 2      continue
        go to (31,32,33),m
 33     x3(jp) = t3
 32     x2(jp) = t2
 31     x1(jp) = t1
 3    continue
      return
      end

*-------------------------------------------------------------------------

      subroutine zero
      common /n/ nn(31)
      common /p/ pp(20)
      in = 31
      ip = 20
      do 1 i = 1,in
        nn(i) = 0
 1    continue
      do 2 i = 1,ip
        pp(i) = 0.
 2    continue
      return
      end

*-------------------------------------------------------------------------

      subroutine plot1(x,y,ix,iy,ndat,iymaz,ys1,yl1,num)

*-----single precision version

*-----plot num curves at points (x,y), curves stored consecutively
*-----ndat(i) = number of points in curve i
*-----n-th curve plotted with symbol ac(n)
*-----call with ix =  = x, iy =  = y...dummies
*--------but dimension separately if x or y is needed later
*-----dimension ndat(num), not needed if num = 1
*-----iymax =  number of actual lines printed minus one
*-----ys1,yl1 = lower and upper values on y-axis (computed if equal)
*-----switch axes if iymax.gt.100

      dimension x(1),y(1),ix(1),iy(1),ndat(1),zx(11),afx(101),ac(50)
      data blx/2h x/,ac/1h*,1h+,1hx,1h.,1h0,1h*,1h+,1hx,1h.,1h0,39*1h*,
     1 1hq/
      ndata = 0
      do 30 i = 1,num
 30   ndata = ndata+ndat(i)
      iymax = iymaz
      if(iymax.eq.0) iymax = 1
      ys = ys1
      yl = yl1
      if(ys.ne.yl) go to 500
      yl = y(1)
      ys = y(1)
      do 501 i = 1,ndata
      yl = amax1(yl,y(i))
 501  ys = amin1(ys,y(i))
 500  continue
      xl = x(1)
      xs = x(1)
      do 502 i = 1,ndata
      xl = amax1(xl,x(i))
      xs = amin1(xs,x(i))
 502  continue
      xw = amax0(100,iymax)
      yw = amin0(100,iymax)
      xscale = (xl-xs)/xw
 503  yscale = (yl-ys)/yw
      if(yscale.ne.0) go to 3000
      yscale = 1.0
      iymax = 0
3000  continue
      if(xscale.ne.0.) go to 3001
      write(16,3002)
 3002 format('0degenerate abcissa encountered in plot1')
      return
 3001 continue
      j = 0
      do 105 i = 1,ndata
104   j = j+1
      ix(j) = (x(i) -xs)/xscale+0.5
      iy(j) = (y(i)-ys)/yscale+0.5
*--------switch axes for long plot
      if(iymax.le.100) go to 105
      it1 = ix(j)
      ix(j) = iy(j)
      iy(j) = it1
 105  continue
      if(iymax.le.100) go to 106
      t1 = ys
      ys = xs
      xs = t1
      t1 = yscale
      yscale = xscale
      xscale = t1
 106  continue
1     format(1h1)
2     format( 2x,  10h y values 3x, 1hi20(5h....i))
4     format(1h , 1pe13.6,     1hi101a1,1hi)
6     format(15x, 1hi20(5h....i))
7     format(6x,1pe13.6,5(7x,1pe13.6)/9x,5(7x,1pe13.6))
8     format(     31x, 9h yscale = 1pe15.7, 6x, 8hxscale = 1pe15.7)
504   write (16,1)
505   write (16,2)
      if(iymax.gt.100) go to 11
9     ll = iymax
      go to 13
10    ll = ll-1
      go to 13
11    ll = 0
      go to 13
12    ll = ll+1
13    do 14 i = 1,101
14    afx(i) = blx
      j = 0
      do 16 ncurve = 1,num
      jmax = ndat(ncurve)
      do 16 k = 1,jmax
      j = j+1
      if (iy(j).ne.ll) go to 16
15    ii = ix(j)+1
      if(ii.le.0.or.ii.gt.101) go to 16
      if(afx(ii).ne.blx.and.afx(ii).ne.ac(ncurve)) go to 400
      afx(ii) = ac(ncurve)
      go to 16
 400  afx(ii) = ac(50)
16    continue
506   zy = float(ll)*yscale+ys
      write (16,4) zy, (afx(i), i = 1,101)
      if (iymax.gt.100) go to 18
17    if(ll) 19,19,10
18    if (ll.lt.iymax) go to 12
19    write (16,6)
      do 20 k = 1,11
20    zx(k) = 10.*float(k-1)*xscale+xs
      write (16,7) (zx(k), k = 1,11,2), (zx(k), k = 2,10,2)
      write (16,8) yscale, xscale
      return
      end

*-------------------------------------------------------------------------
